//+------------------------------------------------------------------+
//|                                                       JK_Lib.mq4 |
//|                Copyright  2006, Jure Kren (jure.kren@gmail.com) |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Jure Kren (jure.kren@gmail.com)"
#property link      ""

//+------------------------------------------------------------------+
//| defines                                                          |
//+------------------------------------------------------------------+
// #define MacrosHello   "Hello, world!"
// #define MacrosYear    2005

//+------------------------------------------------------------------+
//| DLL imports                                                      |
//+------------------------------------------------------------------+
// #import "user32.dll"
//   int      SendMessageA(int hWnd,int Msg,int wParam,int lParam);

// #import "my_expert.dll"
//   int      ExpertRecalculate(int wParam,int lParam);
// #import

//+------------------------------------------------------------------+
//| EX4 imports                                                      |
//+------------------------------------------------------------------+
// #import "stdlib.ex4"
//   string ErrorDescription(int error_code);
// #import
//+------------------------------------------------------------------+

/*
#import "JK_Lib.ex4"
  // OMG ... Are we still in the dark ages????
#import
*/

double Sqr(double x) {
  return (x*x);
}

int Sign(double x) {
  if (x >= 0.0) {
    return (1);
  } else {
    return (-1);
  }
}

double CondD(bool p, double a, double b) {
  if (p) {
    return (a);
  } else {
    return (b);
  }
}

int CondI(bool p, int a, int b) {
  if (p) {
    return (a);
  } else {
    return (b);
  }
}

string CondS(bool p, string a, string b) {
  if (p) {
    return (a);
  } else {
    return (b);
  }
}

//
double MACD(
  int period1, int method1, int price1, 
  int period2, int method2, int price2, 
  int shift) 
{
  double ma1 = iMA(NULL, 0, period1, 0, method1, price1, shift);
  double ma2 = iMA(NULL, 0, period2, 0, method2, price2, shift);
  return (ma1 - ma2);
}

//
double ArrayMACD(
  double& y[],
  int period1, int method1, int price1, 
  int period2, int method2, int price2,
  int start = 0, int count = -1) 
{
  count = CondI(count < 0, ArraySize(y), count);
  for (int i = 0; i < count; i++) {
    y[i] = MACD(period1, method1, price1, period2, method2, price2, start + i);
  }
}

//
void ArrayFirstOrderDiff(double& x[], double& y[], int start = 0, int count = -1) {
  count = CondI(count < 0, ArraySize(y), count);
  for (int i = 0; i < count; i++) {
    y[i] = x[i] - x[i+1];
  }
}

//
void ArrayNthOrderDiff(double& x[], double& y[], int n, int start = 0, int count = -1) {
  for (int i = 0; i < n; i++) {
    ArrayFirstOrderDiff(y, x, start, count);
  }
}

//
void ArrayMultiply(double& x[], double& y[], double k, int start = 0, int count = -1) {
  count = CondI(count < 0, ArraySize(y), count);
  for (int i = 0; i < count; i++) {
    y[i] = x[i]*k;
  }
}

// good-enough string splitting procedure :)
int StrSplit(string str, string delim, string& part[]) {
  // empty string?
  if (StringLen(str) < 1) {
    ArrayResize(part, 0);
    return (0);
  }
  // non-empty string?
  else {
    ArrayResize(part, 258);
    int pos = 0;
    for (int i = 0; pos < (StringLen(str) + 1); i++) {
      int pos_delim = StringFind(str, delim, pos);
      // delimiter not found?
      if (pos_delim < 0) {
        if (ArraySize(part) < i) ArrayResize(part, i*2);
        part[i] = StrPart(str, pos, StringLen(str) - pos);
        pos = StringLen(str) + 1;
      } 
      // delimiter found?
      else {
        if (ArraySize(part) < i) ArrayResize(part, i*2);
        part[i] = StrPart(str, pos, pos_delim - pos);
        pos = pos_delim + StringLen(delim);
      }
    }
    ArrayResize(part, i);
    return (i);
  }
}

// a saner substite for StringSubstr
string StrPart(string str, int pos, int len) {
  return (CondS(len > 0, StringSubstr(str, pos, len), ""));
}

//
string StrLeft(string str, int pos) {
  int len = pos + 1;
  if (len > 0) {
    return (StringSubstr(str, 0, len));
  } else {
    return ("");
  }
}

//
string StrRight(string str, int pos) {
  int len = StringLen(str) - pos;
  if (len > 0) {
    return (StringSubstr(str, pos, len));
  } else {
    return ("");
  }
}

//
int StrToArrayI(string str, string delim, int& array[]) {
  string part[];
  int count = StrSplit(str, delim, part);
  if (count > 0) {
    ArrayResize(array, count);
    for (int i = 0; i < count; i++) {
      array[i] = StrToInteger(part[i]);
    }
  }
  return (count);
}

//
string StrDup(string c, int n) {
  string s = "";
  for (int i = 0; i < n; i++) {
    s = s + c;
  }
  return (s);
}

